--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    12:04:09 08/03/05
-- Design Name:    
-- Module Name:    rnd_test - my_arch
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.vtx_pack.all;
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity rnd_test is
    Port ( clk : in std_logic;
           reset : in std_logic;
           strobe : in std_logic;
           mem_test : in std_logic;
           ddr_w_gnt : in std_logic;
           mem_done : out std_logic; -- stop mem_test when done
           chk_done : in std_logic; -- '1' when read/check of a 32 word block done, if test failed, stay '1'
           rd_blk : out std_logic; -- read and check a block of 32 words
           wr_blk : out std_logic; -- write a block of 64 words to memory w_fifo
           inc_pa : out std_logic); -- increment ddr page register
end rnd_test;

architecture my_arch of rnd_test is
signal w_cnt : std_logic_vector(6 downto 0) := "0000000";
signal w_blk_cnt : std_logic_vector(7 downto 0) := x"00";
signal page_cnt : std_logic_vector(17 downto 0) := "000000000000000000";
signal r_cnt : std_logic_vector(8 downto 0) := "000000000";
signal w_gnt_sync : std_logic := '0';
signal wr_blk_i : std_logic := '0';
signal page_end : std_logic := '0';
signal checking : std_logic := '0';
signal inc_pa_i : std_logic := '0';
signal mem_done_i : std_logic := '0';
signal inc_pa_dl : std_logic := '0';
begin
wr_blk <= wr_blk_i;
inc_pa <= inc_pa_i;
mem_done <= mem_done_i;
process(clk)
begin
  if(clk'event and clk = '1')then
    w_gnt_sync <= ddr_w_gnt or (w_gnt_sync and not strobe);
    if(mem_test = '0')then
	   w_cnt <= (others => '0');
	   w_blk_cnt <= (others => '0');
		wr_blk_i <= '1';
		page_end <= '0';
	   r_cnt <= (others => '0');
		rd_blk <= '0';
		checking <= '0';
	   inc_pa_i <= '0';
	   inc_pa_dl <= '0';
	 elsif(strobe = '1')then
	   if(wr_blk_i = '1')then
	     w_cnt <= w_cnt + 1;
		end if;
		if((w_gnt_sync = '1' and w_blk_cnt /= x"ff") or (inc_pa_dl = '1' and mem_done_i = '0'))then
		  wr_blk_i <= '1';
		elsif(w_cnt = "1111111")then
		  wr_blk_i <= '0';
		end if;
		if(w_gnt_sync = '1')then
		  w_blk_cnt <= w_blk_cnt + 1;
		end if;
		if(w_blk_cnt = x"ff" and w_gnt_sync = '1')then
		  page_end <= '1';
		elsif(r_cnt = "111111111" and chk_done = '1')then
		  page_end <= '0';
		end if;
	   if(chk_done = '1')then
		  r_cnt <= r_cnt + 1;
		end if;
		if((page_end = '1' or w_blk_cnt > r_cnt(8 downto 1))
		  and checking = '0')then
		  rd_blk <= '1';
		  checking <= '1';
		else
		  rd_blk <= '0';
		  checking <= checking and not chk_done;
		end if;
	   if(r_cnt = "111111111" and chk_done = '1')then
		  inc_pa_i <= '1';
		else
		  inc_pa_i <= '0';
		end if;
	   inc_pa_dl <= inc_pa_i;
	 end if;
	 if(reset = '1')then
		mem_done_i <= '0';
		page_cnt <= (others => '0');
	 elsif(strobe = '1')then
	   if(wr_blk_i = '1')then
		  mem_done_i <= '0';
	   elsif(page_cnt = "111111111111111111" and inc_pa_i = '1')then
		  mem_done_i <= '1';
		end if;
		if(inc_pa_i = '1')then
		  page_cnt <= page_cnt + 1;
		end if;
	 end if;
  end if;
end process;

end my_arch;
